import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 * this class constructs the window which is popped-up when selecting "Save every..."
 * from the Options sub-menu in the Settings menu
 */
public class ChangeFrequency implements ActionListener{
    /**
     * the text field where the user can type the new value
     */
    JTextField no_turns;
    /**
     * button to perform the change
     */
    JButton ok;
    /**
     * button to close the window
     */
    JButton dismiss;
    /**
     * parent of this wndow
     */
    JFrame mainframe;
    /**
     * the window
     */
    JDialog dialog;
    /**
     * referrence to the user interface
     */
    UserInterface ui;

    /**
     * builts a JDialog window with a tetfield and the two buttons
     */
    ChangeFrequency(JFrame mainframe, UserInterface ui){
	this.mainframe=mainframe;
	this.ui=ui;
	//the textfield
	no_turns = new JTextField(5);


	//the buttons
	ok = new JButton("Change");
	ok.addActionListener(this);

	dismiss = new JButton("Cancel");
	dismiss.addActionListener(this);
	//the labels
	JLabel t = new JLabel("Save every ");
	JLabel s = new JLabel(" turns");

	//adds controls to the window
	dialog = new JDialog(mainframe,"Save every...");
	dialog.addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent e){
		    dialog.hide();
		}
	    });

	// adds components to the window
	Container c=dialog.getContentPane();
	JPanel nord = new JPanel(new FlowLayout());
	nord.add(t);
	nord.add(no_turns);
	nord.add(s);
	JPanel center = new JPanel(new FlowLayout());
	center.add (ok);
	center.add(dismiss);
	c.setLayout(new BorderLayout());
	c.add(nord,BorderLayout.NORTH);
	c.add(center,BorderLayout.CENTER);
	dialog.pack();

    }

    /**
     * makes visible the window
     */
    public void ShowDialog() {
	no_turns.setText(""+ui.getCurrentDocument().getFrequencytoSave());
	dialog.show();
    }
    /**
     * dismiss the window
     */

    public void HideDialog() {
	dialog.hide();
    }

    /**
     * adds controls to the buttons
     * @see UserInterface#getCurrentDocument()
     * @see Document#setFrequencytoSave(int)
     */
    public void actionPerformed(ActionEvent e) {
	JButton b= (JButton) e.getSource();
	//if OK was clicked
	if(b == ok) {
	    try{
	    //parses the number typed in the textfield
	    int n = Integer.parseInt(no_turns.getText());
	    //if it is not a valid number
	    if((n>ui.getCurrentDocument().getTurnNumber())||(n<1)) n=ui.getCurrentDocument().getFrequencytoSave();
	    //updates the textfiels
	    no_turns.setText(""+n);
	    //updates the document settings
	    ui.getCurrentDocument().setFrequencytoSave(n);
	    dialog.hide();
	    }
	    catch(NumberFormatException ex){
		JOptionPane.showMessageDialog(mainframe,"Please type a number","click OK",JOptionPane.INFORMATION_MESSAGE);
	    }
	}
	//if DISMISS was clicked
	else HideDialog();
    }

}
