import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 * this class allows the user to impose constraints on the statistics
 */
class DialogPattern implements ActionListener{

    JDialog dialog = null;
   
    boolean isShown = false;
    static final int criteria = 23;
    static final int IEcriteria = 3;
    JToggleButton button[] = new JToggleButton[criteria];
    InformationElementList  IEList[] = new InformationElementList[IEcriteria];
    String label[] = {"syntactically correct input", "semantically correct input", "not possibly misunderstood input", "syntactically incorrect input", "semantically incorrect input", "possibly misunderstood input", "syntactically correct output", "semantically correct output", "not possibly misunderstood output", "syntactically incorrect output", "semantically incorrect output", "possibly misunderstood output", "good translation", "intermediate translation", "bad translation", "translation mismatch", "no translation mismatch", "full dialog act preservation", "partial dialog act preservation", "no dialog act preservation", "perfect recognition", "only German turns", "Only English turns"};
    String IElabel[] = {"Translated information elements", "Lost information elements", "Added information elements"};
    JFrame mainframe;
  
    /**
     * builts the window and the widgets
     */
    DialogPattern(JFrame mainframe) {
	this.mainframe = mainframe;
	//   this.ui=ui;
	dialog = new JDialog(mainframe, "Constraints for statistics");
	dialog.addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
		    isShown = false;
		    dialog.hide();
		}
	    });

	Container c = dialog.getContentPane();
	c.setLayout(new BorderLayout());
	JPanel west = new JPanel(new BorderLayout());

	JTabbedPane criteria = new JTabbedPane();
	JTabbedPane input_criteria = new JTabbedPane();
	JPanel icc = new JPanel(new GridLayout(2,0,0,1));
	button[2] = new JToggleButton(label[2],new ImageIcon("up.gif"));
	button[2].addActionListener(this);
	icc.add(button[2]);
	button[5] = new JToggleButton(label[5],new ImageIcon("down.gif"));
	button[5].addActionListener(this);
	icc.add(button[5]);
	input_criteria.addTab("Clarity",icc);
	JPanel icsy = new JPanel(new GridLayout(2,0,0,1));
	button[0] = new JToggleButton(label[0],new ImageIcon("up.gif"));
	button[0].addActionListener(this);
	icsy.add(button[0]);
	button[3] = new JToggleButton(label[3],new ImageIcon("down.gif"));
	button[3].addActionListener(this);
	icsy.add(button[3]);
	input_criteria.addTab("Syntax",icsy);
	JPanel icsem = new JPanel(new GridLayout(2,0,0,1));
	button[1] = new JToggleButton(label[1],new ImageIcon("up.gif"));
	button[1].addActionListener(this);
	icsem.add(button[1]);
	button[4] = new JToggleButton(label[4],new ImageIcon("down.gif"));
	button[4].addActionListener(this);
	icsem.add(button[4]);
	input_criteria.addTab("Semantics",icsem);
	JTabbedPane output_criteria = new JTabbedPane();
	JPanel occ = new JPanel(new GridLayout(2,0,0,1));
	button[8] = new JToggleButton(label[8],new ImageIcon("up.gif"));
	button[8].addActionListener(this);
	occ.add(button[8]);
	button[11] = new JToggleButton(label[11],new ImageIcon("down.gif"));
	button[11].addActionListener(this);
	occ.add(button[11]);
	output_criteria.addTab("Clarity",occ);
	JPanel ocsy = new JPanel(new GridLayout(2,0,0,1));
	button[6] = new JToggleButton(label[6],new ImageIcon("up.gif"));
	button[6].addActionListener(this);
	ocsy.add(button[6]);
	button[9] = new JToggleButton(label[9],new ImageIcon("down.gif"));
	button[9].addActionListener(this);
	ocsy.add(button[9]);
	output_criteria.addTab("Syntax",ocsy);
	JPanel ocsem = new JPanel(new GridLayout(2,0,0,1));
	button[7] = new JToggleButton(label[7],new ImageIcon("up.gif"));
	button[7].addActionListener(this);
	ocsem.add(button[7]);
	button[10] = new JToggleButton(label[10],new ImageIcon("down.gif"));
	button[10].addActionListener(this);
	ocsem.add(button[10]);
	output_criteria.addTab("Semantics",ocsem);
	criteria.addTab("Input",input_criteria);
	criteria.addTab("Output",output_criteria);
	JPanel transl = new JPanel(new GridLayout(6,0,0,1));
	button[12] = new JToggleButton(label[12],new ImageIcon("up.gif"));
	button[12].addActionListener(this);
	transl.add(button[12]);
	button[13] = new JToggleButton(label[13]);
	button[13].addActionListener(this);
	transl.add(button[13]);
	button[14] = new JToggleButton(label[14],new ImageIcon("down.gif"));
	button[14].addActionListener(this);
	transl.add(button[14]);
	button[15] = new JToggleButton(label[15],new ImageIcon("up.gif"));
	button[15].addActionListener(this);
	transl.add(button[15]);
	button[16] = new JToggleButton(label[16],new ImageIcon("down.gif"));
	button[16].addActionListener(this);
	transl.add(button[16]);
	button[20] = new JToggleButton(label[20],new ImageIcon("up.gif"));
	button[20].addActionListener(this);
	transl.add(button[20]);
	criteria.addTab("Translation",transl);
	JPanel da = new JPanel(new GridLayout(3,0,0,1));
	button[17] = new JToggleButton(label[17],new ImageIcon("up.gif"));
	button[17].addActionListener(this);
	da.add(button[17]);
	button[18] = new JToggleButton(label[18]);
	button[18].addActionListener(this);
	da.add(button[18]);
	button[19] = new JToggleButton(label[19],new ImageIcon("down.gif"));
	button[19].addActionListener(this);
	da.add(button[19]);
	criteria.addTab("Dialog Act",da);
	JPanel eg = new JPanel(new GridLayout(2,0,0,1));
	button[21] = new JToggleButton(label[21]);
	button[21].addActionListener(this);
	eg.add(button[21]);
	button[22] = new JToggleButton(label[22]);
	button[22].addActionListener(this);
	eg.add(button[22]);
	criteria.addTab("Language",eg);
	west.add(criteria,BorderLayout.CENTER);
	JPanel ielist = new JPanel(new GridLayout(3,0,0,1));
	IEList[0] = new InformationElementList(IElabel[0]);
	ielist.add(IEList[0]);
	IEList[1] = new InformationElementList(IElabel[1]);
	ielist.add(IEList[1]);
	IEList[2] = new InformationElementList(IElabel[2]);
	ielist.add(IEList[2]);
	west.add(ielist,BorderLayout.SOUTH);
	c.add(west, BorderLayout.WEST);
	JPanel sud = new JPanel(new FlowLayout());

	JButton done = new JButton("Done");
	done.addActionListener(new ActionListener () {
		public void actionPerformed(ActionEvent e) {
		    HideDialog();
		}
	    });
	sud.add(done);

	JButton cancel = new JButton("Cancel");
	cancel.addActionListener(new ActionListener () {
		public void actionPerformed(ActionEvent e) {
		    HideDialog();
		    for(int i=0;i<button.length;i++){
			button[i].setEnabled(true);
			button[i].setSelected(false);
		    }
		}
	    });
	sud.add(cancel);

	c.add(sud, BorderLayout.SOUTH);
	dialog.pack();
    }


   

    /**
     * adds the controls to each button
     * it takes care not to select 2 or more options which can not be satisfied in the same time
     */
    public void actionPerformed(ActionEvent e)
    {
	JToggleButton b=(JToggleButton)e.getSource();
	if (b==button[0]) button[3].setEnabled(!b.isSelected());
	else if((b==button[3])) button[0].setEnabled(!b.isSelected());
	else if(b==button[1]) button[4].setEnabled(!b.isSelected());
	else if(b==button[4]) button[1].setEnabled(!b.isSelected());
	else if(b==button[2]) button[5].setEnabled(!b.isSelected());
	else if(b==button[5]) button[2].setEnabled(!b.isSelected());
	else if(b==button[9]) button[6].setEnabled(!b.isSelected());
	else if(b==button[6]) button[9].setEnabled(!b.isSelected());
	else if(b==button[7]) button[10].setEnabled(!b.isSelected());
	else if(b==button[10]) button[7].setEnabled(!b.isSelected());
	else if(b==button[8]) button[11].setEnabled(!b.isSelected());
	else if(b==button[11]) button[8].setEnabled(!b.isSelected());
	else if(b==button[12]){ button[14].setEnabled(!b.isSelected());button[13].setEnabled(!b.isSelected());}
	else if(b==button[13]){ button[14].setEnabled(!b.isSelected());button[12].setEnabled(!b.isSelected());}
	else if(b==button[14]){ button[12].setEnabled(!b.isSelected());button[13].setEnabled(!b.isSelected());}

	else if(b==button[15]) button[16].setEnabled(!b.isSelected());
	else if(b==button[16]) button[15].setEnabled(!b.isSelected());


	else if(b==button[17]){ button[18].setEnabled(!b.isSelected());button[19].setEnabled(!b.isSelected());}
	else if(b==button[18]){ button[17].setEnabled(!b.isSelected());button[19].setEnabled(!b.isSelected());}
	else if(b==button[19]){ button[17].setEnabled(!b.isSelected());button[18].setEnabled(!b.isSelected());}

	else if(b==button[21]) button[22].setEnabled(!b.isSelected());
	else if(b==button[22]) button[21].setEnabled(!b.isSelected());


    }

    /**
     * dismiss the window
     */
    public void HideDialog() {
	isShown = false;
	dialog.hide();
    }


    /**
     * pops-up the window
     */
    public void ShowDialog() {
	isShown = true;
	dialog.show();
    }

}
