
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.util.StringTokenizer;

/**
 * this class computes statistics concerning different liguistic criteria
 */
public class DialogStatistics implements Runnable{

    // variables used for computing
    float turns;
    float checkedturns;
    float good;
    float intermediate;
    float bad;
    float mismatch;
    float no_mismatch;
    float syn;
    float sem;
    float miss;
    float dialfull;
    float dialpar;
    float dialno;

    float checkedturnstrans;
    float checkedturnsins;
    float checkedturnsdel;
    float goodtrans;
    float intermediatetrans;
    float badtrans;
    float gooddel;
    float intermediatedel;
    float baddel;
    float goodins;
    float intermediateins;
    float badins;
    String data1[] = new String[16];
    boolean isShown=false;
    JDialog dialog;
    UserInterface ui;
    JFrame mainframe;
    //the table model
    DefaultTableModel myModel;
    final String[] columnNames = {"Criteria","Percentage"};
    // the data for the table
    final String[][] data = {   {"Good",""},
				{"Intermediate",""},
				{"Bad",""},
				{"Syntactically correct",""},
				{"Semantically correct",""},
				{"No possible missunderstandings",""},
				{"Translation mismatch",""},
				{"No translation mismatch",""},
				{"Full dialog act preservation",""},
				{"Partial dialog act preservation",""},
				{"No dialog act preservation",""}};
    final String column_aux = "Value";
    final String[] data_aux={"","","","","","","","","","",""}; 

    /**
     * builts the window and addas the components
     */
    public DialogStatistics(JFrame mainframe,UserInterface ui){
	this.ui=ui;
	this.mainframe=mainframe;
	dialog = new JDialog(mainframe,"Dialog Statistics");
	dialog.addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
		    isShown = false;
		    dialog.hide();
		}
	    });

	Container c = dialog.getContentPane();
	c.setLayout(new BorderLayout());


	// the table
	myModel=new DefaultTableModel(data,columnNames);
	myModel.addColumn(column_aux,data_aux);
	JTable table = new JTable(myModel);
	table.setPreferredScrollableViewportSize(new Dimension(500,185));
	JScrollPane scrollPane=new JScrollPane(table);

	c.add(scrollPane,BorderLayout.CENTER);
	JPanel sud = new JPanel(new FlowLayout());
	JButton update = new JButton("update");
	JButton dismiss = new JButton("Close");
	update.addActionListener(new ActionListener () {
		public void actionPerformed(ActionEvent e) {
		    UpdateDialog();
		}
	    });
	dismiss.addActionListener(new ActionListener () {
		public void actionPerformed(ActionEvent e) {
		    HideDialog();
		}
	    });
	sud.add(update);
	sud.add(dismiss);
	c.add(sud, BorderLayout.SOUTH);
	dialog.pack();
	
    }

    /**
     * pops-up the window,starts a thread for the computation, and when it is finished updates the view of the table
     * @see #Changed()
     */
    public void ShowDialog() {
	isShown = true;
	dialog.show();
	Thread t = new Thread(this);
	t.start();
	try{ 
	    t.join();
	}
	catch(InterruptedException e){}
	Changed();

    }

    /**
     * update the computations according to changes performed by the user in the panels in the user interface
     * @see #Changed()
     */
    public void UpdateDialog(){
	isShown=true;
	Thread t = new Thread(this);
	t.start();
	try{t.join();}
	catch(InterruptedException e){}
	Changed();
    }

    /**
     * performs the computations in a thread
     */
    public void run(){
	Calculate();
    }

    /**
     * dismiss the window
     */
    public void HideDialog(){
	isShown = false;
	dialog.hide();
    }


    /**
     * updates the view of the table, according to the new computed values
     */
    public void Changed(){
	String data;
	if(isShown){
	    data=(String)myModel.getValueAt(0,1);
	    data=""+(good/checkedturns)*100+"%";
	    myModel.setValueAt(data,0,1);
	    data=(String)myModel.getValueAt(0,2);
	    data="("+good+"/"+checkedturns+")";
	    myModel.setValueAt(data,0,2);
	    //**
	    data=(String)myModel.getValueAt(1,1);
	    data=""+(intermediate/checkedturns)*100+"%";
	    myModel.setValueAt(data,1,1);     
	    data=(String)myModel.getValueAt(1,2);
	    data="("+intermediate+"/"+checkedturns+")";
	    myModel.setValueAt(data,1,2);      
	    data=(String)myModel.getValueAt(2,1);
	    data=""+(bad/checkedturns)*100+"%";
	    myModel.setValueAt(data,2,1);     
	    data=(String)myModel.getValueAt(2,2);
	    data="("+bad+"/"+checkedturns+")";
	    myModel.setValueAt(data,2,2);     
	    data=(String)myModel.getValueAt(3,1);
	    data=""+(syn/checkedturns)*100+"%";
	    myModel.setValueAt(data,3,1);     
	    data=(String)myModel.getValueAt(3,2);
	    data="("+syn+"/"+checkedturns+")";
	    myModel.setValueAt(data,3,2);     
	    data=(String)myModel.getValueAt(4,1);
	    data=""+(sem/checkedturns)*100+"%";
	    myModel.setValueAt(data,4,1);
	    data=(String)myModel.getValueAt(4,2);
	    data="("+sem+"/"+checkedturns+")";
	    myModel.setValueAt(data,4,2);
	    data=(String)myModel.getValueAt(5,1);
	    data=""+(miss/checkedturns)*100+"%";
	    myModel.setValueAt(data,5,1);
	    data=(String)myModel.getValueAt(5,2);
	    data="("+miss+"/"+checkedturns+")";
	    myModel.setValueAt(data,5,2);
	    data=(String)myModel.getValueAt(6,1);
	    data=""+(mismatch/checkedturns)*100+"%";
	    myModel.setValueAt(data,6,1);
	    data=(String)myModel.getValueAt(6,2);
	    data="("+mismatch+"/"+checkedturns+")";
	    myModel.setValueAt(data,6,2);	
	    data=(String)myModel.getValueAt(7,1);
	    data=""+(no_mismatch/checkedturns)*100+"%";
	    myModel.setValueAt(data,7,1);	
	    data=(String)myModel.getValueAt(7,2);
	    data="("+no_mismatch+"/"+checkedturns+")";
	    myModel.setValueAt(data,7,2);	
	    data=(String)myModel.getValueAt(8,1);
	    data=""+(dialfull/checkedturns)*100+"%";
	    myModel.setValueAt(data,8,1);
	    data=(String)myModel.getValueAt(8,2);
	    data="("+dialfull+"/"+checkedturns+")";
	    myModel.setValueAt(data,8,2);
	    data=(String)myModel.getValueAt(9,1);
	    data=""+(dialpar/checkedturns)*100+"%";
	    myModel.setValueAt(data,9,1);
	    data=(String)myModel.getValueAt(9,2);
	    data="("+dialpar+"/"+checkedturns+")";
	    myModel.setValueAt(data,9,2);
	    data=(String)myModel.getValueAt(10,1);
	    data=""+(dialno/checkedturns)*100+"%";
	    myModel.setValueAt(data,10,1);
	    data=(String)myModel.getValueAt(10,2);
	    data="("+dialno+"/"+checkedturns+")";
	    myModel.setValueAt(data,10,2);
	}

    }
    /**
     * initalize values
     */
    private void init() {
	checkedturns = 0;
	good = 0;
	intermediate = 0;
	bad = 0;
	mismatch = 0;
	no_mismatch = 0;
	syn = 0;
	sem = 0;
	miss = 0;
	dialfull = 0;
	dialpar = 0;
	dialno = 0;
    }

    /**
     * initialize values
     */
    private void initScreen() {
	checkedturnstrans = 0;
	goodtrans = 0;
	intermediatetrans = 0;
	badtrans = 0;
	checkedturnsdel = 0;
	gooddel = 0;
	intermediatedel = 0;
	baddel = 0;
	checkedturnsins = 0;
	goodins = 0;
	intermediateins = 0;
	badins = 0;
    }

    /**
     * get data from the turns
     * 2param j the current turn
     */
    private void GetTurn(Judgements j) {
	data1[0] = (String) j.turn.get("SYNIN");
	data1[1] = (String) j.turn.get("SEMIN");
	data1[2] = (String) j.turn.get("MISIN");
	data1[3] = (String) j.turn.get("SYNOUT");
	data1[4] = (String) j.turn.get("SEMOUT");
	data1[5] = (String) j.turn.get("MISOUT");
	data1[6] = (String) j.turn.get("QUAL");
	data1[7] = (String) j.turn.get("EFF");
	data1[8] = (String) j.turn.get("DIALIN");
	data1[9] = (String) j.turn.get("DIALOUT");
	data1[10] = (String) j.turn.get("NUMIU");
	data1[11] = (String) j.turn.get("NTRNIU");
	data1[12] = (String) j.turn.get("NDELIU");
	data1[13] = (String) j.turn.get("NINNIU");
	data1[14] = (String) j.turn.get("RECQUAL");
	data1[15] = (String) j.turn.get("LANG");
    }

    /**
     * checks if there are constraints for statistics in the Patatrens window
     * @param j the current turn
     */
    private boolean CheckConstraints(Judgements j) {
	GetTurn(j);
	if (data1[0] != null)
	    if ((this.ui.dialog_pattern.button[0].isSelected()) && (!data1[0].equals("1")))
		return false;
	if (data1[1] != null)
	    if ((this.ui.dialog_pattern.button[1].isSelected()) && (!data1[1].equals("1")))
		return false;
	if (data1[2] != null)
	    if ((this.ui.dialog_pattern.button[2].isSelected()) && (!data1[2].equals("0")))
		return false;
	if (data1[0] != null)
	    if ((this.ui.dialog_pattern.button[3].isSelected()) && (!data1[0].equals("0")))
		return false;
	if (data1[1] != null)
	    if ((this.ui.dialog_pattern.button[4].isSelected()) && (!data1[1].equals("0")))
		return false;
	if (data1[2] != null)
	    if ((this.ui.dialog_pattern.button[5].isSelected()) && (!data1[2].equals("1")))
		return false;
	if (data1[3] != null)
	    if ((this.ui.dialog_pattern.button[6].isSelected()) && (!data1[3].equals("1")))
		return false;
	if (data1[4] != null)
	    if ((this.ui.dialog_pattern.button[7].isSelected()) && (!data1[4].equals("1")))
		return false;
	if (data1[5] != null)
	    if ((this.ui.dialog_pattern.button[8].isSelected()) && (!data1[5].equals("0")))
		return false;
	if (data1[3] != null)
	    if ((this.ui.dialog_pattern.button[9].isSelected()) && (!data1[3].equals("0")))
		return false;
	if (data1[4] != null)
	    if ((this.ui.dialog_pattern.button[10].isSelected()) && (!data1[4].equals("0")))
		return false;
	if (data1[5] != null)
	    if ((this.ui.dialog_pattern.button[11].isSelected()) && (!data1[5].equals("1")))
		return false;
	if (data1[6] != null)
	    if ((this.ui.dialog_pattern.button[12].isSelected()) && (!data1[6].equals("1")))
		return false;
	if (data1[6] != null)
	    if ((this.ui.dialog_pattern.button[13].isSelected()) && (!data1[6].equals("3")))
		return false;
	if (data1[6] != null)
	    if ((this.ui.dialog_pattern.button[14].isSelected()) && (!data1[6].equals("0")))
		return false;
	if (data1[7] != null)
	    if ((this.ui.dialog_pattern.button[15].isSelected()) && (!data1[7].equals("1")))
		return false;
	if (data1[7] != null)
	    if ((this.ui.dialog_pattern.button[16].isSelected()) && (!data1[7].equals("0")))
		return false;
	if (data1[8] != null)
	    if ((this.ui.dialog_pattern.button[17].isSelected()) && (!data1[8].equals(data1[9])))
		return false;
	if (data1[8] != null)
	    if ((this.ui.dialog_pattern.button[19].isSelected()) && ((data1[8].equals(data1[9])) || (PartialDialogAct())))
		return false;
	if ((this.ui.dialog_pattern.button[18].isSelected()) && 
	    ((!PartialDialogAct()) || 
	     data1[8].equals(data1[9])))
	    return false;
	if ((this.ui.dialog_pattern.button[20].isSelected())&&((data1[14].equals("0"))))
	    return false;

	if ((this.ui.dialog_pattern.button[21].isSelected())&&((!data1[15].equals("D"))))
	    return false;
	if ((this.ui.dialog_pattern.button[22].isSelected())&&((!data1[15].equals("E"))))
	    return false;

	if (!CheckIE())
	    return false;
	
	return true;
    }
   

    /**
     * computes the statistics
     */
    public void Calculate() {
	String value;
	Judgements j = this.ui.getCurrentDocument().getFirst();
	// initialize variables
	init();
	turns = this.ui.getCurrentDocument().turn_number;
	// compute turn by turn
	for (int i = 0; i<turns; i++) {
	    if (CheckConstraints(j)) {
		checkedturns++;
		// dialog act
		if ((data1[8] != null)&&(data1[9] != null))
		    if (data1[8].equals(data1[9]))
			dialfull++;
		    else {
			if (PartialDialogAct())
			    dialpar++;
			else
			    dialno++;
		    }
		value = (String) j.turn.get("SYNOUT");
		if (value != null)
		    if (value.equals("1"))
			syn++;
		value = (String) j.turn.get("SEMOUT");
		if (value != null)
		    if (value.equals("1"))
			sem++;
		value = (String) j.turn.get("MISOUT");
		if (value != null)
		    if (value.equals("0"))
			miss++;
		value = (String) j.turn.get("QUAL");
		if (value != null)
		    if (value.equals("1"))
			good++;
		    else if (value.equals("0"))
			bad++;
		    else if (value.equals("3"))
			intermediate++;
		value = (String) j.turn.get("EFF");
		if (value != null)
		    if (value.equals("0"))
			no_mismatch++;
		    else if (value.equals("1"))
			mismatch++;
	    }
	    if (i < turns -1 )
		j = (Judgements) j.turn.get("NEXT");	    
	}

    }
    
    private boolean PartialDialogAct() {
	String in_tok;
	String out_tok;
	if ((data1[8] == null)&&(data1[9] != null))
	    return false;
	if ((data1[8] != null)&&(data1[9] == null))
	    return false;
	StringTokenizer in = new StringTokenizer(data1[8], "!");
	StringTokenizer out = new StringTokenizer(data1[9], "!");
	if (out.countTokens() == 0)
	    return false;
	if (in.countTokens() == 0)
	    return false;
	while(in.hasMoreTokens()) {
	    in_tok = new String(in.nextToken());
	    out = new StringTokenizer(data1[9], "!");
	    while(out.hasMoreTokens()) {
		out_tok = new String(out.nextToken()); 
		if (out_tok.equals(in_tok))
		    return true;
	    }
	}
	return false;
    }


    private boolean CheckIE() {
	float TrIEconstrMIN = this.ui.dialog_pattern.IEList[0].getMin();
	float DelIEconstrMIN = this.ui.dialog_pattern.IEList[1].getMin();
	float InsIEconstrMIN = this.ui.dialog_pattern.IEList[2].getMin();
	float TrIEconstrMAX = this.ui.dialog_pattern.IEList[0].getMax();
	float DelIEconstrMAX = this.ui.dialog_pattern.IEList[1].getMax();
	float InsIEconstrMAX = this.ui.dialog_pattern.IEList[2].getMax();
	float Ie;
	float Tr;
	float Del;
	float Ins;
	try {
	    Ie = Integer.parseInt(data1[10]);
	    Tr = Integer.parseInt(data1[11]);
	    Del = Integer.parseInt(data1[12]);
	    Ins = Integer.parseInt(data1[13]);
	}
	catch (NumberFormatException e) {
	    Ie = 0;
	    Tr = 0;
	    Del = 0;
	    Ins = 0;
	    return true;
	}
	
	if ((TrIEconstrMAX != -1) && (TrIEconstrMIN != -1))
	    if ((Tr*100/Ie > TrIEconstrMAX)||(Tr*100/Ie < TrIEconstrMIN))
		return false;
	if ((DelIEconstrMIN != -1) && (DelIEconstrMAX != -1))
	    if ((Del*100/Ie > DelIEconstrMAX)||(Del*100/Ie < DelIEconstrMIN))
		return false;
	if ((InsIEconstrMIN != -1) && (InsIEconstrMAX != -1))
	    if ((Ins*100/Ie > InsIEconstrMAX)||(Ins*100/Ie < InsIEconstrMIN))
		return false;

	return true;
    }
}


