

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 *This class that shows the linguistic correctness of the curent turn to be evaluated. The class extends the JPanel class in order to be directly nested in the layout of the application and implemets the ActionListener interface to listen to the events on the widgets.
*/

public class TurnCorrectnessPanel extends JPanel implements ActionListener {
    // all the widgets
    JRadioButton SyntCorrInYes;
    JRadioButton SyntCorrInNo;
    JRadioButton SemCorrInYes;
    JRadioButton SemCorrInNo;
    JRadioButton MissInYes;
    JRadioButton MissInNo;
    JRadioButton SyntCorrOutYes;
    JRadioButton SyntCorrOutNo;
    JRadioButton SemCorrOutYes;
    JRadioButton SemCorrOutNo;
    JRadioButton MissOutYes;
    JRadioButton MissOutNo;
    // button groups have to be declared here to be able to 
    // set 'no selection' on their widgets
    ButtonGroup gi1;
    ButtonGroup gi2;
    ButtonGroup gi3;
    ButtonGroup go1;
    ButtonGroup go2;
    ButtonGroup go3;
    /**
     *a reference to the global user interface
     */
    UserInterface ui;


    /**
     * This method access the user interface of the application
     */
    public UserInterface getUI(){
	return ui;
    }

    /**
     * The constructor of the class takes as parameter the 
     * reference to the user interface of the application
     * @param ui reference to the user interface of the application
     */
    TurnCorrectnessPanel(UserInterface ui) {
	// creates the main panel and sets its layout
        this.ui=ui;
	this.setLayout(new BorderLayout());
	Color bgcolor = new Color(255, 255, 204);
	// crates a border for the main panel
	this.setBorder(BorderFactory.createEmptyBorder(0,20,0,20));
	// creates and add the 'input' label
	JLabel input = new JLabel("Input");
	this.add(input, BorderLayout.WEST);
	// creates and add the 'output' label
	JLabel output = new JLabel("Output");
	this.add(output, BorderLayout.EAST);
	// creates a panel for the conponet that goes in the center...
	JPanel center  = new JPanel(new BorderLayout());
	// crates a border for the panel in center of main panel
	center.setBorder(BorderFactory.createEmptyBorder(10,20,10,20));
	// ...and creates 3 subpanels for radio buttons and other labels...
	JPanel subwest  = new JPanel(new GridLayout(0,1));
	JPanel subcenter  = new JPanel(new GridLayout(0,1));
	JPanel subeast  = new JPanel(new GridLayout(0,1));
	// ...each of these has three elements...
	// east has three subsubpanel with flowlayout and two radio buttons
        JPanel sspe1 = new JPanel(new FlowLayout());
	go1 = new ButtonGroup();
	SyntCorrOutYes = new JRadioButton("Yes");
	SyntCorrOutYes.setActionCommand("SIN_CORR_OUT_YES");
	SyntCorrOutNo = new JRadioButton("No");
	SyntCorrOutNo.setActionCommand("SIN_CORR_OUT_NO");
	go1.add(SyntCorrOutYes);
	go1.add(SyntCorrOutNo);
        sspe1.add(SyntCorrOutYes);
        sspe1.add(SyntCorrOutNo);	
        JPanel sspe2 = new JPanel(new FlowLayout());
        go2 = new ButtonGroup();
	SemCorrOutYes = new JRadioButton("Yes");
	SemCorrOutYes.setActionCommand("SEM_CORR_OUT_YES");
	SemCorrOutNo = new JRadioButton("No");
	SemCorrOutNo.setActionCommand("SEM_CORR_OUT_NO");
	go2.add(SemCorrOutYes);
	go2.add(SemCorrOutNo);
        sspe2.add(SemCorrOutYes);
        sspe2.add(SemCorrOutNo);		
        JPanel sspe3 = new JPanel(new FlowLayout());
	go3 = new ButtonGroup();
	MissOutYes = new JRadioButton("Yes");
	MissOutYes.setActionCommand("MISS_OUT_YES");
	MissOutNo = new JRadioButton("No");
	MissOutNo.setActionCommand("MISS_OUT_NO");
	go3.add(MissOutYes);
	go3.add(MissOutNo);
        sspe3.add(MissOutYes);
        sspe3.add(MissOutNo);	
	// add to subpanel subwest
	subeast.add(sspe1);
	subeast.add(sspe2);
	subeast.add(sspe3);

	// center has three labels in three panels with FlowLayout
        JPanel ssc1 = new JPanel(new FlowLayout());
        JLabel l1 = new JLabel("Syntactically Correct");
	ssc1.add(l1);
        JPanel ssc2 = new JPanel(new FlowLayout());
        JLabel l2 = new JLabel("Semantically Correct");
	ssc2.add(l2);
        JPanel ssc3 = new JPanel(new FlowLayout());
        JLabel l3 = new JLabel("Possible Misunderstandings");
	ssc3.add(l3);
	subcenter.add(ssc1);
	subcenter.add(ssc2);
	subcenter.add(ssc3);

	// west has three subsubpanel with flowlayout and two radio buttons
        JPanel sspw1 = new JPanel(new FlowLayout());
	gi1 = new ButtonGroup();
	SyntCorrInYes = new JRadioButton("Yes");
	SyntCorrInYes.setActionCommand("SIN_CORR_IN_YES");
	SyntCorrInNo = new JRadioButton("No");
	SyntCorrInNo.setActionCommand("SIN_CORR_IN_NO");
	gi1.add(SyntCorrInYes);
	gi1.add(SyntCorrInNo);
        sspw1.add(SyntCorrInYes);
        sspw1.add(SyntCorrInNo);	
        JPanel sspw2 = new JPanel(new FlowLayout());
	gi2 = new ButtonGroup();
	SemCorrInYes = new JRadioButton("Yes");
	SemCorrInYes.setActionCommand("SEM_CORR_IN_YES");
	SemCorrInNo = new JRadioButton("No");
	SemCorrInNo.setActionCommand("SEM_CORR_IN_NO");
	gi2.add(SemCorrInYes);
	gi2.add(SemCorrInNo);
        sspw2.add(SemCorrInYes);
        sspw2.add(SemCorrInNo);		
        JPanel sspw3 = new JPanel(new FlowLayout());
	gi3 = new ButtonGroup();
	MissInYes = new JRadioButton("Yes");
	MissInYes.setActionCommand("MISS_IN_YES");
	MissInNo = new JRadioButton("No");
	MissInNo.setActionCommand("MISS_IN_NO");
	gi3.add(MissInYes);
	gi3.add(MissInNo);
        sspw3.add(MissInYes);
        sspw3.add(MissInNo);	
	// add to subpanel subwest
	subwest.add(sspw1);
	subwest.add(sspw2);
	subwest.add(sspw3);

	// add to the center
	center.add(subwest, BorderLayout.WEST);
	center.add(subcenter, BorderLayout.CENTER);
	center.add(subeast, BorderLayout.EAST);

	// add to the mainpanel
	this.add(center, BorderLayout.CENTER);
	// add all listeners
	SyntCorrInYes.addActionListener(this);
	SyntCorrInNo.addActionListener(this);
	SyntCorrOutYes.addActionListener(this);
	SyntCorrOutNo.addActionListener(this);
	SemCorrInYes.addActionListener(this);
	SemCorrInNo.addActionListener(this);
	SemCorrOutYes.addActionListener(this);
	SemCorrOutNo.addActionListener(this);
	MissInYes.addActionListener(this);		
	MissInNo.addActionListener(this);
	MissOutYes.addActionListener(this);
	MissOutNo.addActionListener(this);
    }

    /** 
     *this method gets the Source of the action and executes
     *the related action (update the document)
     */	
    public void actionPerformed(ActionEvent e) {	
	if(e.getSource() == SyntCorrInYes) //SYNTAX
	    ui.getCurrentDocument().CurrentTurn.turn.put("SYNIN", "1");
	else if (e.getSource() == SyntCorrInNo) 
	    ui.getCurrentDocument().CurrentTurn.turn.put("SYNIN", "0");
	else if (e.getSource() == SyntCorrOutYes) 
	    ui.getCurrentDocument().CurrentTurn.turn.put("SYNOUT", "1");
	else if (e.getSource() == SyntCorrOutNo) 
	    ui.getCurrentDocument().CurrentTurn.turn.put("SYNOUT", "0");
	else if (e.getSource() == SemCorrInYes)// SEMANTICS
	    ui.getCurrentDocument().CurrentTurn.turn.put("SEMIN", "1");
	else if (e.getSource() == SemCorrInNo) 
	    ui.getCurrentDocument().CurrentTurn.turn.put("SEMIN", "0");
	else if (e.getSource() == SemCorrOutYes) 
	    ui.getCurrentDocument().CurrentTurn.turn.put("SEMOUT", "1");
	else if (e.getSource() == SemCorrOutNo) 
	    ui.getCurrentDocument().CurrentTurn.turn.put("SEMOUT", "0");
	else if (e.getSource() == MissInYes) // POSSIBLE MISUNDERSTANDINGS
	    ui.getCurrentDocument().CurrentTurn.turn.put("MISIN", "1");
	else if (e.getSource() == MissInNo) 
	    ui.getCurrentDocument().CurrentTurn.turn.put("MISIN", "0");
	else if (e.getSource() == MissOutYes) 
	    ui.getCurrentDocument().CurrentTurn.turn.put("MISOUT", "1");
	else if (e.getSource() == MissOutNo) 
	    ui.getCurrentDocument().CurrentTurn.turn.put("MISOUT", "0");
	// activate the save menu
	ui.menu.setSavable(true);
    }
    
    /**	
     * This method updates the panel when the turn to be shown changes
     * @param j is the current turn to be shown
     */
    public void changed(Judgements j) {
	// this variable contains the value of a parameter in the current turn
        String state;
	if(j!=null){
	    // the syntacic input correctness parameter is retrieved...	
	    state = (String) j.turn.get("SYNIN");
	    // ... and the corresponding widget is updated
	    // SYNIN = 1 -> Correct
	    // SYNIN = 0 -> incorrect
	    if (state != null) {
		if (state.equals("0")) {	    
		    SyntCorrInYes.setSelected(false);
		    SyntCorrInNo.setSelected(true);
		}
		else if (state.equals("1")) {
		    SyntCorrInYes.setSelected(true);
		    SyntCorrInNo.setSelected(false);
		}
		else {
		    gi1.setSelected(null, true);
		}
	    }
	    else {
		gi1.setSelected(null, true);
	    }
	    // Same as above
	    state = (String) j.turn.get("SYNOUT");
	    if (state != null) {
		if (state.equals("0")) {	    
		    SyntCorrOutYes.setSelected(false);
		    SyntCorrOutNo.setSelected(true);
		}
		else if (state.equals("1")) {
		    SyntCorrOutYes.setSelected(true);
		    SyntCorrOutNo.setSelected(false);
		}
		else {
		    gi2.setSelected(null, true);
		}
	    }
	    else {
		gi2.setSelected(null, true);
	    }
	    // Same as above
	    state = (String) j.turn.get("SEMIN");
	    if (state != null) {
		if (state.equals("0")) {	    
		    SemCorrInYes.setSelected(false);
		    SemCorrInNo.setSelected(true);
		}
		else if (state.equals("1")) {
		    SemCorrInYes.setSelected(true);
		    SemCorrInNo.setSelected(false);
		}
		else {
		    gi3.setSelected(null, true);
		}
	    }
	    else {
		gi3.setSelected(null, true);
	    }
	    // Same as above
	    state = (String) j.turn.get("SEMOUT");
	    if (state != null) {
		if (state.equals("0")) {	    
		    SemCorrOutYes.setSelected(false);
		    SemCorrOutNo.setSelected(true);
		}
		else if (state.equals("1")) {
		    SemCorrOutYes.setSelected(true);
		    SemCorrOutNo.setSelected(false);
		}
		else {
		    go1.setSelected(null, true);
		}
	    }
	    else {
		go1.setSelected(null, true);
	    }
	    // Same as above
	    state = (String) j.turn.get("MISIN");
	    if (state != null) {
		if (state.equals("0")) {	    
		    MissInYes.setSelected(false);
		    MissInNo.setSelected(true);
		}
		else if (state.equals("1")) {
		    MissInYes.setSelected(true);
		    MissInNo.setSelected(false);
		}
		else {
		    go2.setSelected(null, true);
		}
	    }
	    else {
		go2.setSelected(null, true);
	    }
	    // Same as above
	    state = (String) j.turn.get("MISOUT");
	    if (state != null) {
		if (state.equals("0")) {	    
		    MissOutYes.setSelected(false);
		    MissOutNo.setSelected(true);
		}
		else if (state.equals("1")) {
		    MissOutYes.setSelected(true);
		    MissOutNo.setSelected(false);
		}
		else {
		    go3.setSelected(null, true);
		}
	    }
	    else {
		go3.setSelected(null, true);
	    }
	}
    }

}
