import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * this class builts a type of widget conataining a textfield and two buttons ,
 *  one for increasing the value in the textfield, one for decreasing the value
 */
public class InformationElementCounter extends JPanel implements ActionListener{
    JButton minus1;
    JButton plus1;
    public JTextField number;
    JLabel label;
    String source;
    UserInterface ui;


    public void actionPerformed (ActionEvent e) {
	String command = e.getActionCommand();
	if (command.equals("+"))
	    increase();
	else 
	    decrease();
	
    }

    public InformationElementCounter(String title, String source,UserInterface ui) {
	this.source = source;
	this.ui=ui;
	this.setLayout(new BorderLayout());
	this.setBorder(new EmptyBorder(0,0,20,0));
	label = new JLabel(title);
	this.add(label, BorderLayout.NORTH);
	JPanel batp = new JPanel(new FlowLayout(FlowLayout.LEFT));
	minus1 = new JButton("-");
	minus1.addActionListener(this);
	plus1 = new JButton("+");
	plus1.addActionListener(this);
	number = new JTextField("0", 4);
	number.setHorizontalAlignment(JTextField.RIGHT);
	number.setEditable(false);
	number.addActionListener(this);
	batp.add(minus1);
	batp.add(number);
	batp.add(plus1);
	this.add(batp, BorderLayout.SOUTH);
    }

  

    private void increase() {
	int value;
	try {
	    value = Integer.parseInt(number.getText());
	}
	catch(NumberFormatException e) { value = 0;}
	Integer Counter = new Integer(++value);
	number.setText(Counter.toString());
	this.ui.getCurrentDocument().CurrentTurn.turn.put(source, Counter.toString());
	this.ui.menu.setSavable(true);
    }

   

    private void decrease() {
	int value;
	try {
	    value = Integer.parseInt(number.getText());
	}
	catch(NumberFormatException e) { value = 0;}
	if (value > 0) {
	    Integer Counter = new Integer(--value);
	   
	    number.setText(Counter.toString());
	    this.ui.getCurrentDocument().CurrentTurn.turn.put(source, Counter.toString());
	    this.ui.menu.setSavable(true);
	}
    }
} 
