
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;


/**
 * This class that shows the number of information elements in a turn. 
 * The class extends the JPanel class in order to be directly nested in the layout of the application.

*/
public class InformationElementsPanel extends JPanel implements ActionListener{
    // all the widgets
    InformationElementCounter IE;
    InformationElementCounter EIE;
    InformationElementCounter LIE;
    InformationElementCounter TIE;
    InformationElementCounter AIE;
    JButton plus1;
    JButton minus1;
    JTextField TN;
    JProgressBar TNs;
    JLabel FileName;
    JLabel n;
    // a reference to the user interface
    UserInterface ui;
    JFrame mainframe;
  
    /**
     * Adds controls to the widgets
     */ 
    public void actionPerformed (ActionEvent e) {
	Object source = e.getSource();
	//if the source are the buttons
	if ((source==plus1)||(source==minus1)){
	    String command = e.getActionCommand();
	    if (command.equals(">")){
		increase();
	
	    }
	    else {
		decrease();
	
	    }
	}
	else {//if the source is the textfield
	    try{
	    int turn = Integer.parseInt(TN.getText());
	    if (turn<=0)ui.getCurrentDocument().findTurn(1);
	    else ui.getCurrentDocument().findTurn(turn);
	    if(ui.getAutomaticCompare()){
		    ui.recognizer_dialog.compare_algorithm();
		}
		else
		    ui.recognizer_dialog.compare.setEnabled(true);
	    }
	    catch(NumberFormatException ex){
		JOptionPane.showMessageDialog(mainframe,"Please type a number","Click OK",JOptionPane.INFORMATION_MESSAGE);
	    }
	  
	}
    }

    private void increase() {
	if (ui.getCurrentDocument().getCurrentTurnNumber() < ui.getCurrentDocument().getTurnNumber())
	    {
		int x=ui.getCurrentDocument().getCurrentTurnNumber();
		ui.getCurrentDocument().findTurn(++x);
		if(ui.getAutomaticCompare()){
		    ui.recognizer_dialog.compare_algorithm();
		}
		else
		    ui.recognizer_dialog.compare.setEnabled(true);	    
	    }
    }

    private void decrease() {
	if (ui.getCurrentDocument().getCurrentTurnNumber() > 1){
	    int x = ui.getCurrentDocument().getCurrentTurnNumber();
	    ui.getCurrentDocument().findTurn(--x);
	    if(ui.getAutomaticCompare()){
		    ui.recognizer_dialog.compare_algorithm();
		}
		else
		    ui.recognizer_dialog.compare.setEnabled(true);
	    
	}
    }
    //	}
    
    /**
     * The constructor of the class takes as parameter the 
     * reference to the user interface of the application
     * @param ui reference to the user interface of the application
     */
    public InformationElementsPanel(UserInterface ui, JFrame mainframe) {
	// create the main panel and sets its layout
	this.ui=ui;
	this.mainframe = mainframe;

	//	this.setLayout(new BorderLayout());
	this.setLayout(new BorderLayout());
	// crate a border for the main panel
	this.setBorder(BorderFactory.createEmptyBorder(0,20,0,20));
	// create the information elements panel and sets its layout
	JPanel infelemPanel1 = new JPanel(new GridLayout(3,1,10,0));	
	JPanel infelemPanel2 = new JPanel(new GridLayout(3,1,10,0));	
	// create the text-buttons widgets with the text label
	IE = new InformationElementCounter("Information Elements", "NUMIU",this.ui);
	infelemPanel1.add(IE);
	EIE = new InformationElementCounter("Essential Information Elements", "NESIU",this.ui);
	infelemPanel1.add(EIE);    
	LIE = new InformationElementCounter("Lost Information Elements", "NDELIU",this.ui);
	infelemPanel2.add(LIE);
	TIE = new InformationElementCounter("Translated Information Elements", "NTRNIU",this.ui);
	infelemPanel2.add(TIE);
	AIE = new InformationElementCounter("Added Information Elements", "NINNIU",this.ui);
	infelemPanel2.add(AIE);
	infelemPanel2.setBorder(new EmptyBorder(0,20,0,0));
	// create the turn number panel and sets its layout
	JPanel turnnumberPanel = new JPanel(new BorderLayout());	
	JPanel s_turnnumber = new JPanel(new GridLayout(0,1));
	JLabel l = new JLabel("Turn Number");
	TNs = new JProgressBar(JProgressBar.HORIZONTAL);
	TNs.setValue(0);
	TN = new JTextField("0", 4);
	TN.setHorizontalAlignment(JTextField.CENTER);
	plus1 = new JButton(">");
	plus1.addActionListener(this);
	minus1 = new JButton("<");
	minus1.addActionListener(this);
	TN.addActionListener(this);
	s_turnnumber.add(l);
	s_turnnumber.add(TNs);
	JPanel s_s_turnnumber = new JPanel(new FlowLayout());
	s_s_turnnumber.add(minus1);
	s_s_turnnumber.add(TN);
	s_s_turnnumber.add(plus1);
	s_turnnumber.add(s_s_turnnumber);
	s_turnnumber.setBorder(BorderFactory.createEtchedBorder());
	turnnumberPanel.add(s_turnnumber, BorderLayout.NORTH);
	FileName = new JLabel("No file open");	
	if (ui.getCurrentDocument() != (Document)null) {
	    n=new JLabel("Number of turns loaded "+ui.getCurrentDocument().getTurnNumber());
	}
	else {
	    n=new JLabel("No Turns Loaded!");
	}
	
	s_turnnumber = new JPanel(new GridLayout(2,0));	
	s_turnnumber.add(FileName);
	s_turnnumber.add(n);	
	s_turnnumber.setBorder(new EmptyBorder(35,0,0,0));
	turnnumberPanel.add(s_turnnumber, BorderLayout.SOUTH);
	turnnumberPanel.setBorder(new EmptyBorder(0,0,30,15));
	// add to main panel
	JPanel infelemPanel = new JPanel(new GridLayout(1,2,10,0));
	infelemPanel.add(infelemPanel1);	
	infelemPanel.add(infelemPanel2);	
	this.add(infelemPanel, BorderLayout.WEST);
	this.add(turnnumberPanel, BorderLayout.EAST);	

    }

  
    /**
     * This method updates the panel when the turn to be shown changes
     * @param j is the current turn to be shown
     */
    public void changed(Judgements j) {
	if(j!=null){
	    if (ui.getCurrentDocument() != null) {
		IE.number.setText((String) j.turn.get("NUMIU"));
		EIE.number.setText((String) j.turn.get("NESIU"));
		LIE.number.setText((String) j.turn.get("NDELIU"));
		TIE.number.setText((String) j.turn.get("NTRNIU"));
		AIE.number.setText((String) j.turn.get("NINNIU"));
		int current_turn_number = ui.getCurrentDocument().getCurrentTurnNumber();
		Integer CurrentTurnNumber = new Integer(current_turn_number);
		TN.setText(CurrentTurnNumber.toString());
		TNs.setValue(current_turn_number);
	    }
	}
    }


}
