import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/**
 * this class dispays the next turn to be processed after the current one
 */
public class NextTurnPanel extends JPanel {
    JTextArea NextInput;
    JTextArea NextOutput;
    UserInterface ui;

    /**
     * return a referrence to the object
     */
    public static JPanel CreateNextTurnPanel(UserInterface ui) {
   
	return (new NextTurnPanel(ui));
    }

    /**
     * constructor of the object
     * @param ui is the referrence to the user interface
     */

    NextTurnPanel(UserInterface ui) {
	this.ui=ui;
	// creates the main panel and sets its layout
	this.setLayout(new BorderLayout());
	// crates a border for the panel
	this.setBorder(BorderFactory.createEmptyBorder(0,80,0,80));

	// creates and add the text pane for the input sentence
	NextInput = new JTextArea(4, 20);
	NextInput.setLineWrap(true);
	NextInput.setWrapStyleWord(true);
	NextInput.setEditable(false);
	this.add(new JScrollPane(NextInput,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER), BorderLayout.WEST);
	// creates and add the button
	JLabel label = new JLabel("Next Turn", JLabel.CENTER);
	this.add(label, BorderLayout.CENTER);
	// creates and add the text pane for the output sentence
	NextOutput = new JTextArea(4, 20);
	NextOutput.setLineWrap(true);
	NextOutput.setWrapStyleWord(true);
	NextOutput.setEditable(false);
	this.add(new JScrollPane(NextOutput,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER), BorderLayout.EAST);


    }

 
    /**
     *Fires the changes when a new turn is shown
     *@param j contains the data which is currently displayed
     */
    public void changed(Judgements j) {
	// the output in this text areas has a sense only when original translation is showed
	if(j!=null) {
	    if  (ui.getCurrentDocument().output == 1) {
		if (ui.getCurrentDocument().current_turn_number < ui.getCurrentDocument().turn_number) {
		    Judgements next = (Judgements) ui.getCurrentDocument().CurrentTurn.turn.get("NEXT");
		    if (next.turn.get("IN") != null)
			NextInput.setText(ui.Options.substitute((String) next.turn.get("IN")));
		    else 
			NextInput.setText("");
		    if (next.turn.get("OUT") != null)
			NextOutput.setText(ui.Options.substitute((String) next.turn.get("OUT")));
		    else 
			NextOutput.setText("");
		}
		else {	
		    NextInput.setText("");
		    NextOutput.setText("");
	    
		}
	    }
	}
    }
}
