import java.io.*;

/**
 * this class performs the replacements when the user modifies the Replace characters mask
 */
public class OptionsString{
    UserInterface ui;
    String data[][];
    public OptionsString(UserInterface ui) {
	this.ui=ui;
    }

    /**
     * substitute some substrings in a string. 
     * the substrings to be replaced are in the vector old_tring
     * the substrings to be replaced with are in the vector new_string
     * @param str is the string in which the replacements are performed
     * @return the modified string
     * @see #find_position()
     * @see #ReplaceString(String[],String[],String)
     */
    public String substitute(String str) {
	if ((!str.equals(""))&&(str != null)) {
	    data=ui.repl_char.getData();
	    int pos=find_position();
	    String[] old_string=new String[pos];
	    String[] new_string=new String[pos];
	    for(int j=0;j<pos;j++){
		old_string[j]=data[j][0];
		new_string[j]=data[j][1];
	    }
	    return ReplaceString(old_string,new_string,str);
	}
     
	return str;
    }
    
    /**
     * finds the number of elements different from " " in the userMask
     */
    private int find_position() {
	return ui.repl_char.userMask.getMembersNumber();
    }

    /**
     * @param os a vector containing the strings to be replaced
     * @param ns a vector containing the strigs to replace width
     * @param str the string to be modified
     * @return the modified string
     */
    private String ReplaceString(String[] os, String[] ns, String str) {
	String data = str;
	//StringBuffer is necessary because a String can not be modified
	StringBuffer aux;
	for(int i=0;i<os.length;i++) {
	    //serach first occurence of os[i]	   
	    int pos = data.indexOf(os[i]);
	    while(pos>-1) {
		//builts the StringBuffer based on the current string
		aux=new StringBuffer(data);
		aux.insert(pos,ns[i]);
		aux.delete(pos+ns[i].length(),pos+ns[i].length()+os[i].length());
		//convert the StringBuffer back to a String
		data=aux.toString();
		pos=data.indexOf(os[i]);
	    }
	}
	
	return(data);
    }
}
