import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.StringTokenizer;
import java.beans.*;
import javax.swing.text.*;


/**
 * this class builts the window for comparing two turns of the dialogue with respect to the recognized words

 */
public class RecognizerPanel implements ActionListener,UserOptions {
    //the window
    JDialog dialog = null;
    //the widgets
    JTextPane orig;
    JTextPane recognized;
    JFrame mainframe;
    UserInterface ui;
    JButton dismiss;
    JButton compare;
    /**
     * array of strings containing the words in the iput string
     */
    String[] InWords;
    /**
     * array of strings containing the words in the recognized string
     */
    String[] RecWords;
    /**
     * the input string
     */
    String in;
    /**
     * the recognized string
     */
    String rec;
    String orig_in;
    String orig_rec;
   
    
    //the models for the two JTextComponets
    
    DefaultStyledDocument doc,doc1;
    // defining colors
    SimpleAttributeSet red=new SimpleAttributeSet();
    SimpleAttributeSet black=new SimpleAttributeSet();
    SimpleAttributeSet blue=new SimpleAttributeSet();

    /**
     * pops-up the window
     */
    public void ShowDialog() {
	dialog.pack();
	orig_in = orig.getText();
	orig_rec = recognized.getText();
	if(ui.getAutomaticCompare()){
	    compare.setEnabled(false);
	}
	dialog.show();
    }

    public void initial_state(){
	orig.setText(orig_in);
	recognized.setText(orig_rec);
    }

    /**
     * define the actions on the buttons
     * @see StringCompare#assignClasses()
     * @see StringCompare#result()
     * @see #isRecognitionPerfect(Judgements)
     */
    public void actionPerformed(ActionEvent e) {
	JButton b = (JButton) e.getSource();
	
	if (b == dismiss)
	    // dismiss the window
	    dialog.hide();
	else if(b==compare) {
	    compare_algorithm();
	    //disable the compare button
	    compare.setEnabled(false);
	}
    }


    public void compare_algorithm(){
	//builts the arrays of strings containing the words
	    isRecognitionPerfect(ui.getCurrentDocument().getData());
	    //compare the two arrays
	    StringCompare x=new StringCompare(InWords,RecWords);
	    x.assignClasses();
	    x.result();
	    //highlights the not recognized words
	    highlightWordsInput(x.pos_rec);
	    highlightWordsOutput(x.pos_rec);
    }


    /**
     * highlits the not recognized words in the input string
     * @param s is the matrix provided by the String compare algorithm
     */
    private void highlightWordsInput(int[][] s) {
	//get the string from the textcomponent
	in=orig.getText();
	//parse the string in order to retrieve the words
	StringTokenizer tok=new StringTokenizer(in," ");
	String aux = "";
	boolean sign;
	char last;
	int position=0;
	orig.setText("");
	while(tok.hasMoreTokens()){
	    String elem=tok.nextToken();
	    sign=false;
	    last=elem.charAt(elem.length() - 1);
	    //retieves the word without any punctuation sign at the end
	    if (isDotOrComma(last,elem,elem.length()-1)) {
		elem=elem.substring(0,elem.length()-1);
		sign=true;
	    }
	    //retrieve the position of the word in the text in the recognized words
	    int k=detect(elem, InWords);   
	    if (k>-1)
		//if it was not finf
		if(! find_pos(k,s[0])) {
		    try {
			doc.insertString(position,elem+" ",red);}
		    catch(BadLocationException e){};
		}
		else {
		    //if it was found
		    try {  
			doc.insertString(position,elem+" ",black);}
		    catch(BadLocationException e){};
		}
	    //if there was a sign at the end of the word add it
	    if(sign) {
		position+=elem.length();
		try {
		    doc.insertString(position,""+last,black);
		}
		catch(BadLocationException e){};
		position++;
	    }
	    else {
		position+=elem.length()+1;
	    }
	}
	
    } 
    

    /**
     * highlights the not recognized words in the output string
     */    
    private void highlightWordsOutput(int[][] s) {
	//get the string fromthe TextComponent
	rec=recognized.getText();
	//parses the string
	StringTokenizer tok=new StringTokenizer(rec," ");
	String aux="";
	boolean sign;
	char last;
	int position=0;
	recognized.setText("");
	while(tok.hasMoreTokens()) {
	    String elem=tok.nextToken();
	    sign=false;
	    //if there is a sign at the end of the word
	    last=elem.charAt(elem.length() - 1);
	    if ((last=='.')|| 
		(last==',')||
		(last==';')||
		(last==':')||
		(last=='\"')||
		(last=='\'')||
		(last=='!')||
		(last=='?')){
		elem=elem.substring(0,elem.length() - 1);
		sign=true; 
	    }
	    //retrieve the position of the word in the recognized words
	    int k=detect(elem, RecWords);   
	    if (k>-1)
		//if it was not retrieved
		if(! find_pos(k,s[1])) {
		    try{
			doc1.insertString(position,elem+" ",blue);}
		    catch(BadLocationException e){};
		}
		else {
		    try {  
			doc1.insertString(position,elem+" ",black);}
		    catch(BadLocationException e){};
		}
	    //if there was a punctuation sign at the end of the word
	    if(sign){
		position+=elem.length();
		try{
		    doc1.insertString(position,""+last,black);}
		catch(BadLocationException e){};
		position++;}
	    else{
		position+=elem.length()+1;
	    }
	}
	//if nothing could be retrieved in the recognized Words
	String finalstring =recognized.getText();
	if (finalstring.equals("")) {
	    try {
		doc1.insertString(0,rec,blue);
	    }
	    catch(BadLocationException e){};
	}
	
    } 
    
    
    /**
     * checks the appartenence of a number to a vector of integers
     */
    private boolean find_pos(int s, int[] v){
	int k=0;
	boolean found=false;
	while((k<v.length)&&(!found)){
	    if (s==v[k]) found=true;
	    k++;
	}
	return found;
    }
    

    /**
     * detects if a string is contained in an array of strings ignoring the Upper or Lower cases
     */
    private int detect(String s, String[] v){
	int k=0;
	boolean found=false;
	while((k<v.length)&&(!found)){
	    if (s.equalsIgnoreCase(v[k])) {found=true;return k;}
	    k++;
	}
	return -1;
    }
    
    //builts the window and its components
    public RecognizerPanel(JFrame mainframe,UserInterface ui) {
	this.mainframe = mainframe;
        this.ui=ui;
	// set the characteristics of text pnes
	
	StyleConstants.setForeground(red,new Color(255,0,0));
	StyleConstants.setForeground(black,new Color(0,0,0));
	StyleConstants.setForeground(blue,new Color(0,0,255));
	//builts the widgets
	doc=new DefaultStyledDocument();
	doc1=new DefaultStyledDocument();
	orig = new JTextPane(doc);
	orig.setPreferredSize(new Dimension(400,400));
	recognized = new JTextPane(doc1);
	recognized.setPreferredSize(new Dimension(400,400));

	dialog = new JDialog(mainframe, "Recognized input");
	dialog.setSize(300,300);
	Container c = dialog.getContentPane();
	c.setLayout(new BorderLayout());
	JPanel nord = new JPanel(new BorderLayout());
	
	JPanel nordwest = new JPanel(new GridLayout(2,0,0,4));
	JLabel l = new JLabel("Original input");
	nordwest.add(l);
	l = new JLabel("Recognized input");
	nordwest.add(l);
	nord.add(nordwest, BorderLayout.WEST);

	JPanel nordeast = new JPanel(new GridLayout(2,0,0,4));
	nordeast.add(new JScrollPane(orig));
	nordeast.add(new JScrollPane(recognized));
	nord.add(nordeast);
	c.add(nord, BorderLayout.CENTER);

	JPanel sud = new JPanel(new FlowLayout());
	compare = new JButton("Compare");

	compare.addActionListener(this);
	JButton compareAllG = new JButton("Compare all German turns");
	JButton compareAllE = new JButton("Compare all English turns");
	dismiss = new JButton("Close");
	dismiss.addActionListener(this);
	sud.add(compare);
	sud.add(compareAllG);
	sud.add(compareAllE);
	sud.add(dismiss);
	c.add(sud, BorderLayout.SOUTH);
    }
    
    /**
     * @return a referrence to this window
     */
    public JDialog getTranslationDialog() {
	return dialog;
    }
    

    /**
     * fires changes in the main document
     */
    public void changed(Judgements j) {
	String state;
	if (j !=null){
	    if( (String)j.turn.get("IN")!=null)
		orig.setText(ui.Options.substitute((String) j.turn.get("IN")));
	    else
		orig.setText("");
	    if( (String)j.turn.get("REC")!=null)
		recognized.setText(ui.Options.substitute((String) j.turn.get("REC")));
	    else
		recognized.setText("");
	}
    }
    

    /**
     * bulits the arrays of strings of recognized words and checks if the strings were perfect recognized
     * @param judgement the turn
     */
    public int isRecognitionPerfect(Judgements judgement) {
	in = (String) judgement.turn.get("IN");
	in=ui.Options.substitute(in);

	String rec = (String) judgement.turn.get("REC");
	rec=ui.Options.substitute(rec);
	InWords = new String[MAXIMUM_WORDS_STRING];
	RecWords = new String[MAXIMUM_WORDS_STRING];

	StringTokenizer tok;
	int i, j;

	//delete all boring signs
	in = DeleteDotsAndCommas(in);
	rec = DeleteDotsAndCommas(rec);
	i = 0;
	tok = new StringTokenizer(in, " ");
	while (tok.hasMoreTokens()) {
	    InWords[i] = tok.nextToken(); 
	    i++;
	}
	for(int k=i;k<MAXIMUM_WORDS_STRING;k++) InWords[k]=" ";
	j = 0;
	tok = new StringTokenizer(rec, " ");
	while (tok.hasMoreTokens()) {
	    RecWords[j] = tok.nextToken(); 
	    j++;
	}
	for (int k=j;k<MAXIMUM_WORDS_STRING;k++) RecWords[k]=" ";
	if(i !=j){
	    return 0;
	}
	else{
	    for(i=0;i<j;i++)
		if(!InWords[i].equalsIgnoreCase(RecWords[i]))
		    return 0;
	}
	
	return 1;
    }
    
    /**
     * deletes from a string all punctuation signs
     * @param a_string the string to be changed
     * @return the new string 
     */
    private String DeleteDotsAndCommas(String a_string) {
	String another_string = new String("");
	String final_string=new String("");
	for (int i = 0; i< a_string.length(); i++) {
	    if (!isDotOrComma(a_string.charAt(i),a_string,i))
		another_string += a_string.charAt(i);
	    else{
		if(i<a_string.length()-1)
		    if(!(a_string.charAt(i+1)==' '))
			another_string+=" ";
	    }
	}	
	
	return another_string;     

    }

    /**
     * checks if a character is a punctuation sign
     * @param a_char the char to be checked
     * @param s the string to which the char belongs
     * @param i the position in s where the char appears
     * return true if the character is a punctuation sign
     */
    private boolean isDotOrComma(char a_char,String s,int i) {
	if (a_char == '.')
	    return true;
	if (a_char == ',')
	    return true;
	if (a_char == ';')
	    return true;
	if (a_char == ':')
	    return true;
	if (a_char == '\"') {
	    //checks if is not used for another purposes as part of the word
	    if ((i>0)&& (i<s.length()-1)) return false;
	    return true;
	}
	if (a_char == '\'') {
	    //checks if is not used for another purposes as part of the word
	    if ((i>0)&& (i<s.length()-1)) return false;

	    return true;}
	if (a_char == '!')
	    return true;
	if (a_char == '?')
	    return true;

	return false;
    }

}
