
import java.io.*;
import java.lang.String;
import java.util.*;

/**
 * this class implements the algorithm for comparing the number of words from a string
 *  recognized into another string
 * @see UserOptions
 */
public class StringCompare implements UserOptions{
    String[] input;
    String[] rec;
    Element  matrix[][];
    int max_class=0;
    /**
     * indicates the position of the word with the maximum class in the output string
     */
    int pos_max;
   
    /**
     * records the positions where the common substring is retrieved
     * it has 2 rows and an arbitrary number of columns up to 50 (which is the maximum length of the input string)
     * pos[0] records the positions in the input string
     * pos[1] records the positions in the output string
     */
    int pos_rec[][];
   
    public StringCompare(String[] s1, String[] s2){
	input=s1;
	rec=s2;
	String[] copy;
	Vector position=new Vector();
	int k;
	// length of the input string
	int l= input.length;
	int l_pos;
	//initialization of the work matrix: number of rows equal with the length of the input string
	// variable number of columns
	matrix=new Element[l][];
	//initialization of the output structure
	pos_rec=new int[2][MAXIMUM_WORDS_STRING];
	for(int i=0;i<2;i++)
	    for(int j=0;j<MAXIMUM_WORDS_STRING;j++)
		pos_rec[i][j]=-1;
	// construction of an additional vector holding the positions where a word from the input string is retrieved in the output string
	///this additional vector is used for avoiding the construction of the matrix with a fixed number of columns
	for(int i=0;i<l;i++){
	    //for each word detects the positions
	    copy=s2;
	    k=0;
	    while ((!rec[k].equals(" "))&&(k<rec.length)){
		if(rec[k].equalsIgnoreCase(input[i])){
		    position.add(new Integer(k));}
		// s++;
	 
	    k++;}
	    //for each word constructs the corresponding column in the matrix
	l_pos=position.size();
	//if the word was not found in the recognized string
	if(l_pos==0) {
	    matrix[i]=new Element[1];
	    matrix[i][0]=new Element(-1,0);
	}
	//if the word was recognized
	else{
	matrix[i]= new Element[l_pos];
	for(int j=0;j<l_pos;j++) {
	   
	    matrix[i][j]=new Element(((Integer)position.elementAt(j)).intValue(),0);

	}
	}
	//emty the temporary vector
	position.removeAllElements();

	}      
    }

    public void assignClasses(){
	int l,k;
	boolean find=false;
	//if the last word in the input string occured at least one position in the output string
	if(matrix[matrix.length-1][0].pos>-1) 
	    pos_max=matrix[matrix.length-1][0].pos;
	//i follows each row in the matrix= each word in the input string starting with the one before the latet one
	for (int i=matrix.length-2;i>=0;i--)
	    // j follows each collumn in the corresponding row = each position in the output string
	    for(int j=0;j<matrix[i].length;j++){
		//l looks in the rows after the i_th one
		for(l=i+1;l<matrix.length;l++){
		//k computes the first position greate than  the current one matrix[j].pos
		k=searchFirstElem(matrix[i][j].pos,l);
		//if there is such a position
		if(k>-1){
		    find=true;
		    //finds the maximum class of the elements on positions greater than k
		    //from the initial construction the positions are ordered
		    if(matrix[i][j].classes<=maximum(l,k)) matrix[i][j].classes=maximum(l,k);}
		}
		if (find) matrix[i][j].classes++;
		find=false;
		//computes the maximum class of all words until this moment and the corresponding position
		if ((max_class<= matrix[i][j].classes)&&(matrix[i][j].pos>-1)) {
		    max_class=matrix[i][j].classes;
		    pos_max=i;
		}
	    }
	
    }

    private int searchFirstElem(int x,int y){
	int j=0;
	boolean ok=false;
	while ((j<matrix[y].length)&& (!ok)){
	    if (x < matrix[y][j].pos) {ok=!ok;return j;}
	    j++;
	}
	return -1;
	}

    private int maximum(int x,int y){
	int aux= matrix[x][y].classes;
	for(int k=y+1;k<matrix[x].length;k++)
	    if (aux<matrix[x][k].classes) aux=matrix[x][k].classes;
	return aux;
    }
    
public void result(){
	for (int i=0;i<matrix.length;i++){
	    QuickSort Ob = new QuickSort(matrix[i]); 
	    matrix[i] = Ob.sort(0,matrix[i].length-1);
	 
}

	if (matrix[pos_max][0].pos>-1){


	pos_rec[0][0]=pos_max;
	pos_rec[1][0]=matrix[pos_max][0].pos;
	int kk=1;
	for(int i=pos_max+1;i<input.length;i++){
	   
	    if((matrix[i][0].pos!=-1)&&((matrix[i][0].classes)+1==max_class)) {
	
		pos_rec[1][kk]=matrix[i][0].pos;
		pos_rec[0][kk]=i;

		kk++;
		max_class=matrix[i][0].classes;
	    }
	}
	

}

}

    //*******

    class Element{
	int classes;
	int pos;
	public Element(int x,int y){
	    pos=x;classes=y;
	}
    }

    //**************************************
class QuickSort {
  Element[] vector; 

  QuickSort(Element [] v) { this.vector=v; }

  int poz(int p, int u) {
    int i=p, j=u, ii=0, jj=-1, k;
    Element temp;
    while (i<j) {
      if ( vector[i].classes> vector[j].classes) { }
      else { 
        temp=vector[i]; vector[i]=vector[j]; vector[j]=temp; 
        k=ii; ii=-jj; jj=-k;
      }  
      i=i+ii; j=j+jj;
    }
    return i;
  }

  Element[] sort(int p, int u) {
    int k;
    if ( (u-p)<1 ) { }
    else { 
      k=poz(p,u); 
      if (k>=0) sort(p,k-1);
      if (k+1<=vector.length-1) sort(k+1,u); }
    return(vector);
  }
}

}
    
