import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.StringTokenizer;
import javax.swing.text.*;
import javax.swing.border.*;

/**
 * this clas allows the user to assign weights to the translations produced by each module
 */
public class TranslationPanel implements ActionListener {
    static final String tag[] = {"ALI", "STAT", "SYN", "DEEP"};
    JDialog dialog = null;
    DefaultStyledDocument doc[] = new DefaultStyledDocument[4];
    SimpleAttributeSet normal = new SimpleAttributeSet();
    SimpleAttributeSet bold = new SimpleAttributeSet();
    SimpleAttributeSet blue = new SimpleAttributeSet();
    SimpleAttributeSet green = new SimpleAttributeSet();
    SimpleAttributeSet red = new SimpleAttributeSet();
    JTextPane tp[]= new JTextPane[4];
    JTextField best[] = new JTextField[4];
    String outtext;
    String alitext;
    String stattranstext;
    String syndialogtext;
    String deeptext;
    JButton update;
    JFrame mainframe;
    UserInterface ui;

    public void ShowDialog() {
	dialog.pack();
	dialog.show();
    }

    public void actionPerformed(ActionEvent e) {
	if(e.getSource()==update){
	    for(int i=0;i<4;i++){
	String name = give_name(best[i]);
	String value = Check(best[i], name);
	if (!value.equals("")) {
	    ui.getCurrentDocument().CurrentTurn.turn.put("BEST", value);

	    ui.menu.setSavable(true);

	    UpdateText(ui.getCurrentDocument().CurrentTurn);
	}
	}
	    update.setEnabled(false);
	}
	else{ update.setEnabled(true);}

    }
    
    

    private String give_name(JTextField source) {
	String name;
	if (source == best[0])
	    name = new String("ali");
	else if (source == best[1])
	    name = new String("stat");
	else if (source == best[2])
	    name = new String("syn");
	else if (source == best[3])
	    name = new String("deep");
	else
	    name = new String("What object was?");
	
	return name;
    }


    public TranslationPanel(JFrame mainframe, UserInterface ui) {
	//set the styles
	StyleConstants.setBold(bold, true); 
	StyleConstants.setForeground(bold, new Color(0,0,255)); 
	StyleConstants.setForeground(green, new Color(0,255,0)); 
	StyleConstants.setForeground(red, new Color(255,0,0)); 
	// set the characteristics of text areas
	doc[0] = new DefaultStyledDocument();
	tp[0] = new JTextPane(doc[0]);	
	doc[1] = new DefaultStyledDocument();
	tp[1] = new JTextPane(doc[1]);	
	doc[2] = new DefaultStyledDocument();
	tp[2] = new JTextPane(doc[2]);	
	doc[3] = new DefaultStyledDocument();
	tp[3] = new JTextPane(doc[3]);	

	tp[0].setEditable(false);
	tp[1].setEditable(false);
	tp[2].setEditable(false);
	tp[3].setEditable(false);
        this.mainframe=mainframe;
        this.ui=ui;
	dialog = new JDialog(this.mainframe, "Translation modules output");
	Container c = dialog.getContentPane();
	c.setLayout(new BorderLayout());
	JPanel nord = new JPanel(new BorderLayout());

	GridLayout lm = new GridLayout(4,0,0,4);
	JPanel nordwest = new JPanel(lm);
	JLabel l = new JLabel("Cased based translation");
	l.setBorder(new EmptyBorder(4,4,4,4));
	nordwest.add(l);
	l = new JLabel("Statistical translation");
	l.setBorder(new EmptyBorder(4,4,4,4));
	nordwest.add(l);
	l = new JLabel("Dialog based translation");
	l.setBorder(new EmptyBorder(4,4,4,4));
	nordwest.add(l);
	l = new JLabel("Deep analysis");
	l.setBorder(new EmptyBorder(4,4,4,4));
	nordwest.add(l);
	nord.add(nordwest, BorderLayout.WEST);

	lm = new GridLayout(0,1);
	JPanel nordeast = new JPanel(lm);
	nordeast = new JPanel(new GridLayout(4,0,0,4));
	nordeast.add(new JScrollPane(tp[0]));
	nordeast.add(new JScrollPane(tp[1]));
	nordeast.add(new JScrollPane(tp[2]));
	nordeast.add(new JScrollPane(tp[3]));
	nord.add(nordeast);
	c.add(nord, BorderLayout.CENTER);
	
	// add a column of checkbuttons for the best translation(s)
	JPanel west = new JPanel(new GridLayout(0,1));
	best[0] = new JTextField(5);
	best[0].addActionListener(this);
	west.add(best[0]);
	best[1] = new JTextField(5);
	best[1].addActionListener(this);
	west.add(best[1]);
	best[2] = new JTextField(5);
	best[2].addActionListener(this);
	west.add(best[2]);
	best[3] = new JTextField(5);
	best[3].addActionListener(this);
	west.add(best[3]);

	c.add(west, BorderLayout.WEST);
	

	JPanel sud = new JPanel(new FlowLayout());
	update=new JButton("Update");
	update.setEnabled(false);
	update.addActionListener(this);
	sud.add(update);
	JButton dismiss = new JButton("Close");
	dismiss.addActionListener(new ActionListener () {
		public void actionPerformed(ActionEvent e) {
		    dialog.hide();
		}
	    });
	sud.add(dismiss);
	c.add(sud, BorderLayout.SOUTH);
	SetVoid();
    }
    
    public JDialog getTranslationDialog() {
	return dialog;
    }
    

    public void changed(Judgements j) {
	String text;
	String name;
	// best boxes
	if(j!=null){
 	SetVoid();
 	String value = (String) j.turn.get("BEST");
 	if (value != null) {
 	    StringTokenizer tok = new StringTokenizer(value, "|");
 	    while (tok.hasMoreTokens()) {
 		value = tok.nextToken();  
		StringTokenizer intok = new StringTokenizer(value, ":"); 
		while (intok.hasMoreTokens()) {
		    name = intok.nextToken(); 
		    if (intok.hasMoreTokens()) {
			text = intok.nextToken(); 
			SetValue(name, text);
		    }
		}
 	    }
 	}

	// update text boxes
	UpdateText(j);}
    }



   

    private void UpdateText(Judgements j) {
	String text;
	int number;
	int token_number;
	boolean found;
	for (int i = 0; i < 4; i++) {
	    token_number = 0;
	    text = (String) j.turn.get(tag[i]);
	    if (text != null) {
		text = ui.Options.substitute(text);
		tp[i].setText("");
		StringTokenizer text_tok = new StringTokenizer(text, "|");
		while (text_tok.hasMoreTokens()) {
		    text = text_tok.nextToken();
		    token_number++;
		    try {
		    if (token_number > 1)
			doc[i].insertString(doc[i].getLength(), ("| "), bold);
		    } catch (BadLocationException e) {}
		    found = false;
		    try {
			StringTokenizer sequence_tok = new StringTokenizer(best[i].getText(), ",");
			if (sequence_tok.countTokens() > 0) {
			    while (sequence_tok.hasMoreTokens()) {
				try {
				    number = Integer.parseInt((sequence_tok.nextToken()).trim());
				    if (number == token_number) {	
					if (isSelected(text, number, j, i))
					    doc[i].insertString(doc[i].getLength(), text, green);
					else
					    doc[i].insertString(doc[i].getLength(), text, red);
					found = true;
				    }
				} catch (NumberFormatException e) {}
			    }
			    if (!found) {
			    doc[i].insertString(doc[i].getLength(), text, normal);
			    }
			}   
			else 
			    doc[i].insertString(doc[i].getLength(), text, normal);
		    }
		    catch (BadLocationException e) {}		
		}
	    }
	    else
		tp[i].setText("");
	}
    } 


    private boolean isDotOrComma(char a_char) {
	if (a_char == '.')
	    return true;
	if (a_char == ',')
	    return true;
	if (a_char == ',')
	    return true;
	if (a_char == ';')
	    return true;
	if (a_char == ':')
	    return true;
	if (a_char == '\"')
	    return true;
	if (a_char == '\'')
	    return true;
	if (a_char == '!')
	    return true;
	if (a_char == '?')
	    return true;

	return false;
    }


    private String DeleteDotsAndCommas(String a_string) {
	String another_string = new String("");
	for (int i = 0; i< a_string.length(); i++) {
	    if (!isDotOrComma(a_string.charAt(i)))
		another_string += a_string.charAt(i);
	}
	
	return another_string;    
    }


    private boolean isSelected(String segment, int number, Judgements j, int i) {
	String text;
	int token_number = 0;
	text = (String) j.turn.get("OUT");
	StringTokenizer text_tok = new StringTokenizer(text, "|");
	while (text_tok.hasMoreTokens()) {
	    text = text_tok.nextToken();
	    token_number++;
	    text = text.trim();
	    segment = segment.trim();
	    text = DeleteDotsAndCommas(text);
	    segment = DeleteDotsAndCommas(segment);
	    if (number == token_number)
		if (text.equalsIgnoreCase(segment)) 
		    return true;

	}
	return false;
    }

    private void SetValue(String name, String text) {
	if (name.equals("ali"))
	    best[0].setText(text);
	if (name.equals("stat"))
	    best[1].setText(text);
	if (name.equals("syn"))
	    best[2].setText(text);
	if (name.equals("deep"))
	    best[3].setText(text);
    }


    private void SetVoid() {
	best[0].setText("");
	best[1].setText("");
	best[2].setText("");
	best[3].setText("");
    }



    private String Check(JTextField field, String name) {
	String text = field.getText();
	String out = new String("");
	if (CheckSyntax(text)) {
	    // retrive the actual value from all text fields
	    out += "ali:"+best[0].getText() + "|";
	    out += "stat:"+best[1].getText() + "|";
	    out += "syn:"+best[2].getText() + "|";
	    out += "deep:"+best[3].getText();
	    return out;
	}
	else {
	    JOptionPane.showMessageDialog(mainframe,"The format you chose is not correct!\n Try with something more similar to the examples below: \n\"1, 3, 6\" to indicate that the translation to choose are the 1st, the 3rd and the 6th\nNumbers must be in increasing order", "Error!", JOptionPane.ERROR_MESSAGE); 
	    SetValue(name, "");
	    return "";
	}
    }

    private boolean CheckSyntax(String text) {
	int number = 0;
	int previous = 0;
	if (text == null)
	    return true;
	StringTokenizer tok = new StringTokenizer(text, ",");
	while (tok.hasMoreTokens()) {
	    text = tok.nextToken();
	    text = text.trim();
	    try {
		number = Integer.parseInt(text);
		if (number <= previous)
		    return false;
		previous = number;
	    }
	    catch(NumberFormatException e) {return false;}
	}
	
	return true;
    }
    
    
}
